SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'JuanIgnacio 5/1/2013 19:47'!
blueGhost

	^Ghost new.! !

!PacManTest methodsFor: 'actors' stamp: 'JuanIgnacio 5/1/2013 19:51'!
blueberry

	^Fruit new.! !

!PacManTest methodsFor: 'movements' stamp: 'JuanIgnacio 5/1/2013 19:48'!
down

	^(0 @ -1)! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanIgnacio 5/1/2013 20:07'!
ghostHouseDoorType

	^GhostHouseDoorType new.! !

!PacManTest methodsFor: 'movements' stamp: 'JuanIgnacio 5/1/2013 19:47'!
left

	^(-1 @ 0)! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanIgnacio 5/1/2013 21:08'!
leftTransporterType

	^TransporterType new.! !

!PacManTest methodsFor: 'actors' stamp: 'JuanIgnacio 5/1/2013 19:51'!
pacman

	^Pacman new.! !

!PacManTest methodsFor: 'movements' stamp: 'JuanIgnacio 5/1/2013 19:48'!
right

	^(1@0)! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanIgnacio 5/1/2013 19:52'!
spaceType

	^SpaceType new.
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'JuanIgnacio 5/1/2013 19:49'!
up

	^(0 @ 1)! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanIgnacio 5/1/2013 19:47'!
wallType

	^WallType new.! !

Object subclass: #Actor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Actor methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 21:00'!
moveInto: aGhostHouseDoorType going: aDirection 
	^self subclassResponsibility .! !

!Actor methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 20:58'!
position
	^self subclassResponsibility ! !

Actor subclass: #Fruit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Fruit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 23:41'!
moveInto: aConstructionBlockType going: aDirection 
	^aConstructionBlockType moveFruit: self going: aDirection.! !

!Fruit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 19:51'!
position
	^(0 @ 0)! !

Actor subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 20:36'!
moveInto: aGhostHouseDoorType going: aDirection
	^aGhostHouseDoorType moveGhost: self going: aDirection
	! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 19:47'!
position
	^0@0! !

Actor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 23:40'!
moveInto: aConstructionBlockType going: aDirection 
	^aConstructionBlockType movePacman: self going: aDirection! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 19:51'!
position
	^(0 @ 0)! !

Object subclass: #ConstructionBlockType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!ConstructionBlockType methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 23:35'!
nextPositionFor: anActor going: aDirection
	^self subclassResponsibility .	! !

ConstructionBlockType subclass: #GhostHouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 20:42'!
moveFruit: aFruit going: aDirection
	^aFruit position + aDirection! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 20:37'!
moveGhost: aGhost going: aDirection 
	^aGhost position  + aDirection! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 20:40'!
movePacman: aPacman going: aDirection 
	^aPacman position! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 20:33'!
nextPositionFor: anActor going: aDirection
	^anActor moveInto: self going: aDirection.	

"	(anActor isKindOf: Pacman) ifTrue: [ ^ anActor position].
	(anActor isKindOf: Ghost) ifTrue: [ ^anActor position + aDirection ].
	(anActor isKindOf: Fruit) ifTrue: [ ^anActor position + aDirection ]."! !

ConstructionBlockType subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 19:53'!
nextPositionFor: anActor going: aDirection
	^anActor position + aDirection ! !

ConstructionBlockType subclass: #TransporterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!TransporterType methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 23:42'!
moveFruit: aFruit going: aDirection
	^(5@ 10)! !

!TransporterType methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 23:42'!
moveGhost: aGhost going: aDirection
	^aGhost position! !

!TransporterType methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 23:40'!
movePacman: aPacman going: aDirection 
	^(3@10)! !

!TransporterType methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 23:43'!
nextPositionFor: anActor going: aDirection
	^anActor moveInto: self going: aDirection 
"	(anActor isKindOf: Pacman) ifTrue: [ ^ 3@10 ].
	(anActor isKindOf: Fruit) ifTrue: [ ^5@10 ]"! !

ConstructionBlockType subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/1/2013 19:48'!
nextPositionFor: anActor going: aPoint 
	^anActor position! !
